//{$DEFINE Debug}
//{$UNDEF Debug}
unit untGlobal;
// SNXʂŎgO[oϐ

interface

uses
  Classes, Messages, SysUtils, SyncObjs,
  untFolderAlias, untDolibLogin, untConfig, untTool,untDownload,untViewImageForm,
  IniFiles,
  untTaskManager;

const
  APP_NAME = 'katju88';


type
  TFrameworkErrorType = (etNoError, etAbone, etParse, etPostArticle,
                         etDatFreezed, etSocketError, etBrokenGZip, etBoardState,etTimeOut);

  TFrameworkError = procedure(Sender: TObject;
                              const ErrorCode: TFrameworkErrorType;
                              const ErrorString: string) of object;

  TBBSType = (btAuto, bt2ch, btDolib, btKako, btJBBS, btShitaraba,
              btMitinoku, btYahoo, btWinny, btOpen2ch, btNone);

  TSynchronizer = class(TThread)
  protected
    procedure Execute; override;
  public
    procedure DoSynchronize(m: TThreadMethod);
    procedure DoProcessMessage;
  end;

  function GetBBSType(const Server: string): TBBSType;
{$IFDEF Debug}
  procedure AddLog(s: string); overload;
  procedure AddLog(v: Integer); overload;
{$ENDIF}
  function ReTitle(s: string): string;
  function ReplaceAA(s: string): string;
  function LoadCookie(): string;
  procedure SaveCookie(s: string);


var
  gConfig:      TConfig;
  gFolderAlias: TFolderAlias;
  gDolibLogin:  TDolibLogin;
  gTaskManager: TTaskManager;
  gSynchronizer: TSynchronizer;
  gEvent: TSimpleEvent;
  gDownload: TDownload;
  gViewImage: TViewImageForm;
  gExecute: boolean;

implementation

uses
  ActiveX, Forms;

procedure TSynchronizer.DoProcessMessage;
begin
  Application.ProcessMessages;
end;

procedure TSynchronizer.DoSynchronize(m: TThreadMethod);
begin
  Synchronize(m);
end;

procedure TSynchronizer.Execute;
begin
  // ĂяoȂ
end;

function GetBBSType(const Server: string): TBBSType;
begin
  // BBSType𔻒f

  //20140308 Open2chǉ ftHg2chɂ
  result := bt2ch;

  if (Pos('machi.to', Server) > 0) or
     (Pos('machibbs.com', Server) > 0) or
     (Pos('jbbs', Server) > 0) then
    result := btJBBS;

  if (Pos('shitaraba.com', Server) > 0) then
    result := btShitaraba;

  if (Pos('www.mitinoku.jp', Server) > 0) then
    result := btMitinoku;

  if (Pos('open2ch.net', Server) > 0) then
    result := btOpen2ch;

end;
//------------------------------------------------------------------
//
// Oo͂
//
//------------------------------------------------------------------
{$IFDEF Debug}
procedure AddLog(s: string);
var
  f: TextFile;
//NowTime: TDateTime;
//Year,Month,Day,Hour,Min,Sec,MSec: Word;
//iTime: string;
  PathName: string;
  str: string;
begin
  if gExecute<>true then
  begin
    gExecute:=true;
    PathName:=ChangeFileExt(Application.ExeName,'.log');
//  PathName:=AppPath('')

    AssignFile(f,PathName);
    if FileExists(PathName) = True then
    begin
      Append(f);
    end
    else
    begin
      Rewrite(f);
    end;

    str:=DateTimeToStr(Now());
    str:=str+' ';
    str:=str+s;

    Writeln(f,str);
    Flush(f);
    CloseFile(f);
    gExecute:=false;
  end;
end;
{$ELSE}
//
{$ENDIF}
//
//
//
{$IFDEF Debug}
procedure AddLog(v: Integer);
var
  s: string;
begin
  s:=Format('%d',[v]);
  AddLog(s);
end;
{$ELSE}
//
{$ENDIF}
//------------------------------------------------------------------
//
//  G[ʒutbZ[W\
//
//------------------------------------------------------------------
//	procedure ShowmessageEx(s: string);
//	var
//	  str: string;
//	begin
//	
//		AnsiString str;\
//		str.printf("%s\n%s\n%d",__FILE__,__FUNC__,__LINE__);\
//		MSG(str.c_str(),"MSG_FUNC");\
//		}
//	
//	    Showmessage(str);
//	end;
//------------------------------------------------------------------
//
//
//
//------------------------------------------------------------------
function ReTitle(s: string): string;
//var
//str: string;

begin
	result:=s;
	result := StringReplace(result, '&gt;'  , '>', [rfReplaceAll]);
	result := StringReplace(result, '&lt;'  , '<', [rfReplaceAll]);
	result := StringReplace(result, '&amp;' , '&', [rfReplaceAll]);
	result := StringReplace(result, '&quot;', '"', [rfReplaceAll]);
	result := StringReplace(result, '&&'    , '&', [rfReplaceAll]);
end;
//------------------------------------------------------------------
//
//
//
//------------------------------------------------------------------
function ReplaceAA(s: string): string;
//var
//str: string;

begin
	result:=s;
	result := StringReplace(result, '&&'    , '&', [rfReplaceAll]);

	result := StringReplace(result, '&quot;','"', [rfReplaceAll]);			//	&quot; " &#34; " quotation mark = APL quote p 
	result := StringReplace(result, '&amp;','&', [rfReplaceAll]);			//	&amp; & &#38; & ampersand AhL 
	result := StringReplace(result, '&apos;','''', [rfReplaceAll]);			//	&apos; &apos; &#39; ' apostrophe A|XgtB 
	result := StringReplace(result, '&lt;','<', [rfReplaceAll]);			//	&lt; < &#60; < less-than sign s(菬) 
	result := StringReplace(result, '&gt;','>', [rfReplaceAll]);			//	&gt; > &#62; > greater-than sign s() 

	result := StringReplace(result, '&nbsp;',' ', [rfReplaceAll]);			//	&nbsp;   &#160;   no-break space = non-breaking space EsȂ
	result := StringReplace(result, '&iexcl;','!', [rfReplaceAll]);			//	&iexcl; ! &#161; ! inverted exclamation mark tQ 
	result := StringReplace(result, '&cent;','', [rfReplaceAll]);			//	&cent;  &#162;  cent sign ZgL 
	result := StringReplace(result, '&pound;','', [rfReplaceAll]);		//	&pound;  &#163;  pound sign |hL 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&curren; ? &#164; ? currency sign sʉ݋L 
	result := StringReplace(result, '&yen;','\', [rfReplaceAll]);			//	&yen; \ &#165; \ yen sign = yuan sign ~L 
	result := StringReplace(result, '&brvbar;','|', [rfReplaceAll]);		//	&brvbar; | &#166; | broken bar = broken vertical bar c 
	result := StringReplace(result, '&sect;','', [rfReplaceAll]);			//	&sect;  &#167;  section sign ߋL 
	result := StringReplace(result, '&uml;','N', [rfReplaceAll]);			//	&uml; N &#168; N diaeresis = spacing diaeresis L(EEg) 
	result := StringReplace(result, '&copy;','c', [rfReplaceAll]);			//	&copy; c &#169; c copyright sign 쌠\L 
	result := StringReplace(result, '&ordf;','a', [rfReplaceAll]);			//	&ordf; a &#170; a feminine ordinal indicator W 
	result := StringReplace(result, '&laquo;','', [rfReplaceAll]);		//	&laquo;  &#171;  left-pointing double angle quotation mark = left pointing guillemet nߓdRʈpL, n߃M 
	result := StringReplace(result, '&not;','', [rfReplaceAll]);			//	&not;  &#172;  not sign _ےL 
	result := StringReplace(result, '&shy;','-', [rfReplaceAll]);			//	&shy; - &#173; - soft hyphen = discretionary hyphen P̓rŐ܂ԂꍇɂnCt(܂Ԃ̂Ȃꍇ͕\Ȃ) 
	result := StringReplace(result, '&reg;','R', [rfReplaceAll]);			//	&reg; R &#174; R registered sign = registered trade mark sign o^WL 
	result := StringReplace(result, '&macr;','P', [rfReplaceAll]);			//	&macr; P &#175; P macron = spacing macron = overline = APL overbar , I[o[C 
	result := StringReplace(result, '&deg;','', [rfReplaceAll]);			//	&deg;  &#176;  degree sign xL 
	result := StringReplace(result, '&plusmn;','}', [rfReplaceAll]);		//	&plusmn; } &#177; } plus-minus sign = plus-or-minus sign vX}CiXL 
	result := StringReplace(result, '&sup2;','2', [rfReplaceAll]);			//	&sup2; 2 &#178; 2 superscript two = superscript digit two = squared 2,  
	result := StringReplace(result, '&sup3;','3', [rfReplaceAll]);			//	&sup3; 3 &#179; 3 superscript three = superscript digit three = cubed 3, O 
	result := StringReplace(result, '&acute;','L', [rfReplaceAll]);		//	&acute; L &#180; L acute accent = spacing acute g 
	result := StringReplace(result, '&micro;','', [rfReplaceAll]);		//	&micro;  &#181;  micro sign ~NL 
	result := StringReplace(result, '&para;','', [rfReplaceAll]);			//	&para;  &#182;  pilcrow sign = paragraph sign iL 
	result := StringReplace(result, '&middot;','E', [rfReplaceAll]);		//	&middot; E &#183; E middle dot = Georgian comma = Greek middle dot  
	result := StringReplace(result, '&cedil;','C', [rfReplaceAll]);		//	&cedil; C &#184; C cedilla = spacing cedilla ZfB (CȂǂC̉̃R}`̕) 
	result := StringReplace(result, '&sup1;','1', [rfReplaceAll]);			//	&sup1; 1 &#185; 1 superscript one = superscript digit one 1 
	result := StringReplace(result, '&ordm;','o', [rfReplaceAll]);			//	&ordm; o &#186; o masculine ordinal indicator jW 
	result := StringReplace(result, '&raquo;','', [rfReplaceAll]);		//	&raquo;  &#187;  right-pointing double angle quotation mark = right pointing guillemet IdRʈpL, IM 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&frac14; ? &#188; ? vulgar fraction one quarter = fraction one quarter l̈ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&frac12; ? &#189; ? vulgar fraction one half = fraction one half 񕪂̈ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&frac34; ? &#190; ? vulgar fraction three quarters = fraction three quarters l̎O 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&iquest; ? &#191; ? inverted question mark = turned question mark t^╄ 
	result := StringReplace(result, '&Agrave;','A', [rfReplaceAll]);		//	&Agrave; A &#192; A latin capital A with grave = latin capital A grave }啶A 
	result := StringReplace(result, '&Aacute;','A', [rfReplaceAll]);		//	&Aacute; A &#193; A latin capital A with acute g啶A 
	result := StringReplace(result, '&Acirc;','A', [rfReplaceAll]);			//	&Acirc; A &#194; A latin capital A with circumflex Ȑ܃ANZg啶A 
	result := StringReplace(result, '&Atilde;','A', [rfReplaceAll]);		//	&Atilde; A &#195; A latin capital A with tilde `_啶A 
	result := StringReplace(result, '&Auml;','A', [rfReplaceAll]);			//	&Auml; A &#196; A latin capital A with diaeresis L啶A 
	result := StringReplace(result, '&Aring;','A', [rfReplaceAll]);			//	&Aring; A &#197; A atin capital A with ring above = latin capital A ring O啶A 
	result := StringReplace(result, '&AElig;','A', [rfReplaceAll]);			//	&AElig; A &#198; A latin capital AE = latin capital ligature AE AE̍ 
	result := StringReplace(result, '&Ccedil;','C', [rfReplaceAll]);		//	&Ccedil; C &#199; C latin capital C with cedilla ZfB啶C 
	result := StringReplace(result, '&Egrave;','E', [rfReplaceAll]);		//	&Egrave; E &#200; E latin capital E with grave }啶E 
	result := StringReplace(result, '&Eacute;','E', [rfReplaceAll]);		//	&Eacute; E &#201; E latin capital E with acute g啶E 
	result := StringReplace(result, '&Ecirc;','E', [rfReplaceAll]);			//	&Ecirc; E &#202; E latin capital E with circumflex Ȑ܃ANZg啶E 
		result := StringReplace(result, '&Euml;','E', [rfReplaceAll]);		//	&Euml; E &#203; E latin capital E with diaeresis L啶E 
		result := StringReplace(result, '&Igrave;','I', [rfReplaceAll]);	//	&Igrave; I &#204; I latin capital I with grave }啶I 
		result := StringReplace(result, '&Iacute;','I', [rfReplaceAll]);	//	&Iacute; I &#205; I latin capital I with acute g啶I 
		result := StringReplace(result, '&Icirc;','I', [rfReplaceAll]);		//	&Icirc; I &#206; I latin capital I with circumflex Ȑ܃ANZg啶I 
		result := StringReplace(result, '&Iuml;','I', [rfReplaceAll]);		//	&Iuml; I &#207; I latin capital I with diaeresis L啶I 
		result := StringReplace(result, '&ETH;','D', [rfReplaceAll]);		//	&ETH; D &#208; D latin capital ETH [ACXh]啶ETH 
		result := StringReplace(result, '&Ntilde;','N', [rfReplaceAll]);	//	&Ntilde; N &#209; N latin capital N with tilde `_啶N 
		result := StringReplace(result, '&Ograve;','O', [rfReplaceAll]);	//	&Ograve; O &#210; O latin capital O with grave }啶O 
		result := StringReplace(result, '&Oacute;','O', [rfReplaceAll]);	//	&Oacute; O &#211; O latin capital O with acute g啶O 
		result := StringReplace(result, '&Ocirc;','O', [rfReplaceAll]);		//	&Ocirc; O &#212; O latin capital O with circumflex Ȑ܃ANZg啶O 
		result := StringReplace(result, '&Otilde;','O', [rfReplaceAll]);	//	&Otilde; O &#213; O latin capital O with tilde `_啶O 
		result := StringReplace(result, '&Ouml;','O', [rfReplaceAll]);		//	&Ouml; O &#214; O latin capital O with diaeresis L啶O 
		result := StringReplace(result, '&times;','~', [rfReplaceAll]);	//	&times; ~ &#215; ~ multiplication sign ZL 
		result := StringReplace(result, '&Oslash;','O', [rfReplaceAll]);	//	&Oslash; O &#216; O latin capital O with stroke = latin capital O slash ł啶O 
		result := StringReplace(result, '&Ugrave;','U', [rfReplaceAll]);	//	&Ugrave; U &#217; U latin capital U with grave }啶U 
		result := StringReplace(result, '&Uacute;','U', [rfReplaceAll]);	//	&Uacute; U &#218; U latin capital U with acute g啶U 
		result := StringReplace(result, '&Ucirc;','U', [rfReplaceAll]);		//	&Ucirc; U &#219; U latin capital U with circumflex Ȑ܃ANZg啶U 
		result := StringReplace(result, '&Uuml;','U', [rfReplaceAll]);		//	&Uuml; U &#220; U latin capital U with diaeresis L啶U 
		result := StringReplace(result, '&Yacute;','Y', [rfReplaceAll]);	//	&Yacute; Y &#221; Y latin capital Y with acute g啶Y 
		result := StringReplace(result, '&THORN;','T', [rfReplaceAll]);		//	&THORN; T &#222; T latin capital THORN [ACXh]啶THORN 
		result := StringReplace(result, '&szlig;','s', [rfReplaceAll]);		//	&szlig; s &#223; s latin small sharp s = ess-zed hCcGXcFbg 
		result := StringReplace(result, '&agrave;','a', [rfReplaceAll]);	//	&agrave; a &#224; a latin small a with grave = latin small a grave }a 
		result := StringReplace(result, '&aacute;','a', [rfReplaceAll]);	//	&aacute; a &#225; a latin small a with acute ga 
		result := StringReplace(result, '&acirc;','a', [rfReplaceAll]);		//	&acirc; a &#226; a latin small a with circumflex Ȑ܃ANZga 
		result := StringReplace(result, '&atilde;','a', [rfReplaceAll]);	//	&atilde; a &#227; a latin small a with tilde `_a 
		result := StringReplace(result, '&auml;','a', [rfReplaceAll]);		//	&auml; a &#228; a latin small a with diaeresis La 
		result := StringReplace(result, '&aring;','a', [rfReplaceAll]);		//	&aring; a &#229; a latin small a with ring above = latin small a ring Oa 
		result := StringReplace(result, '&aelig;','a', [rfReplaceAll]);		//	&aelig; a &#230; a latin small ae = latin small ligature ae ae̍ 
		result := StringReplace(result, '&ccedil;','c', [rfReplaceAll]);	//	&ccedil; c &#231; c latin small c with cedilla ZfBc 
		result := StringReplace(result, '&egrave;','e', [rfReplaceAll]);	//	&egrave; e &#232; e latin small e with grave }e 
		result := StringReplace(result, '&eacute;','e', [rfReplaceAll]);	//	&eacute; e &#233; e latin small e with acute ge 
		result := StringReplace(result, '&ecirc;','e', [rfReplaceAll]);		//	&ecirc; e &#234; e latin small e with circumflex Ȑ܃ANZge 
		result := StringReplace(result, '&euml;','e', [rfReplaceAll]);		//	&euml; e &#235; e latin small e with diaeresis Le 
		result := StringReplace(result, '&igrave;','i', [rfReplaceAll]);	//	&igrave; i &#236; i latin small i with grave }i 
		result := StringReplace(result, '&iacute;','i', [rfReplaceAll]);	//	&iacute; i &#237; i latin small i with acute gi 
		result := StringReplace(result, '&icirc;','i', [rfReplaceAll]);		//	&icirc; i &#238; i latin small i with circumflex Ȑ܃ANZgi 
		result := StringReplace(result, '&iuml;','i', [rfReplaceAll]);		//	&iuml; i &#239; i latin small i with diaeresis Li 
		result := StringReplace(result, '&eth;','d', [rfReplaceAll]);		//	&eth; d &#240; d latin small eth [ACXh]eth 
		result := StringReplace(result, '&ntilde;','n', [rfReplaceAll]);	//	&ntilde; n &#241; n latin small n with tilde `_n 
		result := StringReplace(result, '&ograve;','o', [rfReplaceAll]);	//	&ograve; o &#242; o latin small o with grave }o 
		result := StringReplace(result, '&oacute;','o', [rfReplaceAll]);	//	&oacute; o &#243; o latin small o with acute go 
		result := StringReplace(result, '&ocirc;','o', [rfReplaceAll]);		//	&ocirc; o &#244; o latin small o with circumflex Ȑ܃ANZgo 
		result := StringReplace(result, '&otilde;','o', [rfReplaceAll]);	//	&otilde; o &#245; o latin small o with tilde `_o 
		result := StringReplace(result, '&ouml;','o', [rfReplaceAll]);		//	&ouml; o &#246; o latin small o with diaeresis Lo 
		result := StringReplace(result, '&divide;','', [rfReplaceAll]);	//	&divide;  &#247;  division sign ZL 
		result := StringReplace(result, '&oslash;','o', [rfReplaceAll]);	//	&oslash; o &#248; o latin small o with stroke, = latin small o slash ło 
		result := StringReplace(result, '&ugrave;','u', [rfReplaceAll]);	//	&ugrave; u &#249; u latin small u with grave }u 
		result := StringReplace(result, '&uacute;','u', [rfReplaceAll]);	//	&uacute; u &#250; u latin small u with acute gu 
		result := StringReplace(result, '&ucirc;','u', [rfReplaceAll]);		//	&ucirc; u &#251; u latin small u with circumflex Ȑ܃ANZgu 
		result := StringReplace(result, '&uuml;','u', [rfReplaceAll]);		//	&uuml; u &#252; u latin small u with diaeresis Lu 
		result := StringReplace(result, '&yacute;','y', [rfReplaceAll]);	//	&yacute; y &#253; y latin small y with acute gy 
		result := StringReplace(result, '&thorn;','t', [rfReplaceAll]);		//	&thorn; t &#254; t latin small letter thorn [ACXh]thorn 
		result := StringReplace(result, '&yuml;','y', [rfReplaceAll]);		//	&yuml; y &#255; y latin small y with diaeresis Ly 

//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&OElig; ? &#338; ? latin capital ligature OE OE̍ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&oelig; ? &#339; ? latin small ligature oe oe̍ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&Scaron; ? &#352; ? latin capital letter S with caron L啶S 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&scaron; ? &#353; ? latin small letter s with caron Ls 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&Yuml; ? &#376; ? latin capital letter Y with diaeresis L啶Y 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&fnof; ? &#402; ? latin small f with hook = function = florin ֐ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&circ; ? &#710; ? modifier letter circumflex accent Ȑ܃ANZg 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&tilde; ? &#732; ? small tilde `_ 

	result := StringReplace(result, '&Alpha;','', [rfReplaceAll]);		//	&Alpha;  &#913;  greek capital letter alpha [MV]啶At@ 
	result := StringReplace(result, '&Beta;','', [rfReplaceAll]);			//	&Beta;  &#914;  greek capital letter beta [MV]啶x[^ 
	result := StringReplace(result, '&Gamma;','', [rfReplaceAll]);		//	&Gamma;  &#915;  greek capital letter gamma [MV]啶K} 
	result := StringReplace(result, '&Delta;','', [rfReplaceAll]);		//	&Delta;  &#916;  greek capital letter delta [MV]啶f^ 
	result := StringReplace(result, '&Epsilon;','', [rfReplaceAll]);		//	&Epsilon;  &#917;  greek capital letter epsilon [MV]啶CvV 
	result := StringReplace(result, '&Zeta;','', [rfReplaceAll]);			//	&Zeta;  &#918;  greek capital letter zeta [MV]啶[[^ 
	result := StringReplace(result, '&Eta;','', [rfReplaceAll]);			//	&Eta;  &#919;  greek capital letter eta [MV]啶G[^ 
	result := StringReplace(result, '&Theta;','', [rfReplaceAll]);		//	&Theta;  &#920;  greek capital letter theta [MV]啶V[^ 
	result := StringReplace(result, '&Iota;','', [rfReplaceAll]);			//	&Iota;  &#921;  greek capital letter iota [MV]啶CI^ 
	result := StringReplace(result, '&Kappa;','', [rfReplaceAll]);		//	&Kappa;  &#922;  greek capital letter kappa [MV]啶Jbp 
	result := StringReplace(result, '&Lambda;','', [rfReplaceAll]);		//	&Lambda;  &#923;  greek capital letter lambda [MV]啶_ 
	result := StringReplace(result, '&Mu;','', [rfReplaceAll]);			//	&Mu;  &#924;  greek capital letter mu [MV]啶~[ 
	result := StringReplace(result, '&Nu;','', [rfReplaceAll]);			//	&Nu;  &#925;  greek capital letter nu [MV]啶j[ 
	result := StringReplace(result, '&Xi;','', [rfReplaceAll]);			//	&Xi;  &#926;  greek capital letter xi [MV]啶NTC 
	result := StringReplace(result, '&Omicron;','', [rfReplaceAll]);		//	&Omicron;  &#927;  greek capital letter omicron [MV]啶I~N 
	result := StringReplace(result, '&Pi;','', [rfReplaceAll]);			//	&Pi;  &#928;  greek capital letter pi [MV]啶pC 
	result := StringReplace(result, '&Rho;','', [rfReplaceAll]);			//	&Rho;  &#929;  greek capital letter rho [MV]啶[ 
	result := StringReplace(result, '&Sigma;','', [rfReplaceAll]);		//	&Sigma;  &#931;  greek capital letter sigma [MV]啶VO} 
	result := StringReplace(result, '&Tau;','', [rfReplaceAll]);			//	&Tau;  &#932;  greek capital letter tau [MV]啶^E 
	result := StringReplace(result, '&Upsilon;','', [rfReplaceAll]);		//	&Upsilon;  &#933;  greek capital letter upsilon [MV]啶EvV 
	result := StringReplace(result, '&Phi;','', [rfReplaceAll]);			//	&Phi;  &#934;  greek capital letter phi [MV]啶t@C 
	result := StringReplace(result, '&Chi;','', [rfReplaceAll]);			//	&Chi;  &#935;  greek capital letter chi [MV]啶JC 
	result := StringReplace(result, '&Psi;','', [rfReplaceAll]);			//	&Psi;  &#936;  greek capital letter psi [MV]啶vTC 
	result := StringReplace(result, '&Omega;','', [rfReplaceAll]);		//	&Omega;  &#937;  greek capital letter omega [MV]啶IK 
	result := StringReplace(result, '&alpha;','', [rfReplaceAll]);		//	&alpha;  &#945;  greek small letter alpha [MV]At@ 
	result := StringReplace(result, '&beta;','', [rfReplaceAll]);			//	&beta;  &#946;  greek small letter beta [MV]x[^ 
	result := StringReplace(result, '&gamma;','', [rfReplaceAll]);		//	&gamma;  &#947;  greek small letter gamma [MV]K} 
	result := StringReplace(result, '&delta;','', [rfReplaceAll]);		//	&delta;  &#948;  greek small letter delta [MV]f^ 
	result := StringReplace(result, '&epsilon;','', [rfReplaceAll]);		//	&epsilon;  &#949;  greek small letter epsilon [MV]CvV 
	result := StringReplace(result, '&zeta;','', [rfReplaceAll]);			//	&zeta;  &#950;  greek small letter zeta [MV][[^ 
	result := StringReplace(result, '&eta;','', [rfReplaceAll]);			//	&eta;  &#951;  greek small letter eta [MV]C[^ 
	result := StringReplace(result, '&theta;','', [rfReplaceAll]);		//	&theta;  &#952;  greek small letter theta [MV]V[^ 
	result := StringReplace(result, '&iota;','', [rfReplaceAll]);			//	&iota;  &#953;  greek small letter iota [MV]CI^ 
	result := StringReplace(result, '&kappa;','', [rfReplaceAll]);		//	&kappa;  &#954;  greek small letter kappa [MV]Jbp 
	result := StringReplace(result, '&lambda;','', [rfReplaceAll]);		//	&lambda;  &#955;  greek small letter lambda [MV]_ 
	result := StringReplace(result, '&mu;','', [rfReplaceAll]);			//	&mu;  &#956;  greek small letter mu [MV]~[ 
	result := StringReplace(result, '&nu;','', [rfReplaceAll]);			//	&nu;  &#957;  greek small letter nu [MV]j[ 
	result := StringReplace(result, '&xi;','', [rfReplaceAll]);			//	&xi;  &#958;  greek small letter xi [MV]NTC 
	result := StringReplace(result, '&omicron;','', [rfReplaceAll]);		//	&omicron;  &#959;  greek small letter omicron [MV]I~N 
	result := StringReplace(result, '&pi;','', [rfReplaceAll]);			//	&pi;  &#960;  greek small letter pi [MV]pC 
	result := StringReplace(result, '&rho;','', [rfReplaceAll]);			//	&rho;  &#961;  greek small letter rho [MV][ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&sigmaf; ? &#962; ? greek small letter final sigma [MV]t@CiVO} 
	result := StringReplace(result, '&sigma;','', [rfReplaceAll]);		//	&sigma;  &#963;  greek small letter sigma [MV]VO} 
	result := StringReplace(result, '&tau;','', [rfReplaceAll]);			//	&tau;  &#964;  greek small letter tau [MV]^E 
	result := StringReplace(result, '&upsilon;','', [rfReplaceAll]);		//	&upsilon;  &#965;  greek small letter upsilon [MV]EvV 
	result := StringReplace(result, '&phi;','', [rfReplaceAll]);			//	&phi;  &#966;  greek small letter phi, [MV]t@C 
	result := StringReplace(result, '&chi;','', [rfReplaceAll]);			//	&chi;  &#967;  greek small letter chi [MV]JC 
	result := StringReplace(result, '&psi;','', [rfReplaceAll]);			//	&psi;  &#968;  greek small letter psi [MV]vTC 
	result := StringReplace(result, '&omega;','', [rfReplaceAll]);		//	&omega;  &#969;  greek small letter omega [MV]IK 

//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&thetasym; ? &#977; ? greek small letter theta symbol [MV]V[^V{ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&upsih; ? &#978; ? greek upsilon with hook symbol [MV]tbNEvVV{ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&piv; ? &#982; ? greek pi symbol [MV]pCV{ 

//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&ensp; ? &#8194; ? en space n̎̋̕(pXy[X) 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&emsp; ? &#8195; ? em space m̎̋̕(SpXy[X) 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&thinsp; ? &#8201; ? thin space ܂ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&zwnj; ? &#8204; ? zero width non-joiner ̖h~ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&zwj; ? &#8205; ? zero width joiner ̋ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lrm; ? &#8206; ? left-to-right mark ̕E 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&rlm; ? &#8207; ? right-to-left mark ̕E獶 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&ndash; ? &#8211; ? en dash 񕪃_[V, _bV() 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&mdash; ? &#8212; ? em dash Sp_bV 
	result := StringReplace(result, '&lsquo;','e', [rfReplaceAll]);		//	&lsquo; e &#8216; e left single quotation mark VOp 
	result := StringReplace(result, '&rsquo;','f', [rfReplaceAll]);		//	&rsquo; f &#8217; f right single quotation mark EVOp 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&sbquo; ? &#8218; ? single low-9 quotation mark VOp 
	result := StringReplace(result, '&ldquo;','g', [rfReplaceAll]);		//	&ldquo; g &#8220; g left double quotation mark _up 
	result := StringReplace(result, '&rdquo;','h', [rfReplaceAll]);		//	&rdquo; h &#8221; h right double quotation mark E_up 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&bdquo; ? &#8222; ? double low-9 quotation mark _up 
	result := StringReplace(result, '&dagger;','', [rfReplaceAll]);		//	&dagger;  &#8224;  dagger W, _K[, Z 
	result := StringReplace(result, '&Dagger;','', [rfReplaceAll]);		//	&Dagger;  &#8225;  double dagger dW, _u_K[, dZ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&bull; ? &#8226; ? bullet = black small circle  
	result := StringReplace(result, '&hellip;','c', [rfReplaceAll]);		//	&hellip; c &#8230; c horizontal ellipsis = three dot leader O_[_ 
	result := StringReplace(result, '&permil;','', [rfReplaceAll]);		//	&permil;  &#8240;  per mille sign p[~L 
	result := StringReplace(result, '&prime;','', [rfReplaceAll]);		//	&prime;  &#8242;  prime = minutes = feet vC(, tB[g) 
	result := StringReplace(result, '&Prime;','', [rfReplaceAll]);		//	&Prime;  &#8243;  double prime = seconds = inches dvC(b, C`) 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lsaquo; ? &#8249; ? single left-pointing angle quotation mark nߎR 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&rsaquo; ? &#8250; ? single right-pointing angle quotation mark IR 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&oline; ? &#8254; ? overline = spacing overscore I[o[XRA 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&frasl; ? &#8260; ? fraction slash ̎ΐ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&euro; ? &#8364; ? euro sign [L 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&image; ? &#8465; ? blackletter capital I = imaginary part [w] 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&weierp; ? &#8472; ? script capital P = power set = Weierstrass p [w]ׂW 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&real; ? &#8476; ? blackletter capital R = real part symbol [w] 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&trade; ? &#8482; ? trade mark sign WL  
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&alefsym; ? &#8501; ? alef symbol = first transfinite cardinal [w]AtL 
	result := StringReplace(result, '&larr;','', [rfReplaceAll]);			//	&larr;  &#8592;  leftwards arrow  
	result := StringReplace(result, '&uarr;','', [rfReplaceAll]);			//	&uarr;  &#8593;  upwards arrow  
	result := StringReplace(result, '&rarr;','', [rfReplaceAll]);			//	&rarr;  &#8594;  rightwards arrow E 
	result := StringReplace(result, '&darr;','', [rfReplaceAll]);			//	&darr;  &#8595;  downwards arrow  
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&harr; ? &#8596; ? left right arrow E 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&crarr; ? &#8629; ? downwards arrow with corner leftwards = carriage return ^[L[L 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lArr; ? &#8656; ? leftwards double arrowd 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&uArr; ? &#8657; ? upwards double arrow d 
	result := StringReplace(result, '&rArr;','', [rfReplaceAll]);			//	&rArr;  &#8658;  rightwards double arrow Ed 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&dArr; ? &#8659; ? downwards double arrow d 
	result := StringReplace(result, '&hArr;','', [rfReplaceAll]);			//	&hArr;  &#8660;  left right double arrow Ed 
	result := StringReplace(result, '&forall;','', [rfReplaceAll]);		//	&forall;  &#8704;  for all [w]ׂĂ(ʌq) 
	result := StringReplace(result, '&part;','', [rfReplaceAll]);			//	&part;  &#8706;  partial differential f, EhfB[ 
	result := StringReplace(result, '&exist;','', [rfReplaceAll]);		//	&exist;  &#8707;  there exists [w]݂(݌q) 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&empty; ? &#8709; ? empty set = null set = diameter [w]W 
	result := StringReplace(result, '&nabla;','', [rfReplaceAll]);		//	&nabla;  &#8711;  nabla = backward difference [w]iu 
	result := StringReplace(result, '&isin;','', [rfReplaceAll]);			//	&isin;  &#8712;  element of [w] 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&notin; ? &#8713; ? not an element of [w]Ȃ 
	result := StringReplace(result, '&ni;','', [rfReplaceAll]);			//	&ni;  &#8715;  contains as member [w]ƂĊ܂ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&prod; ? &#8719; ? n-ary product = product sign [w] 
	result := StringReplace(result, '&sum;','', [rfReplaceAll]);			//	&sum;  &#8721;  n-ary sumation [w]a 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&minus; ? &#8722; ? minus sign }CiXL 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lowast; ? &#8727; ? asterisk operator AX^XN 
	result := StringReplace(result, '&radic;','', [rfReplaceAll]);		//	&radic;  &#8730;  square root = radical sign [w] 
	result := StringReplace(result, '&prop;','', [rfReplaceAll]);			//	&prop;  &#8733;  proportional to [w] 
	result := StringReplace(result, '&infin;','', [rfReplaceAll]);		//	&infin;  &#8734;  infinity  
	result := StringReplace(result, '&ang;','', [rfReplaceAll]);			//	&ang;  &#8736;  angle [w]p 
	result := StringReplace(result, '&and;','', [rfReplaceAll]);			//	&and;  &#8743;  logical and [w]y(), _ 
	result := StringReplace(result, '&or;','', [rfReplaceAll]);			//	&or;  &#8744;  logical or = vee [w](), _a 
	result := StringReplace(result, '&cap;','', [rfReplaceAll]);			//	&cap;  &#8745;  intersection = cap [w]ʏW 
	result := StringReplace(result, '&cup;','', [rfReplaceAll]);			//	&cup;  &#8746;  union = cup [w]W 
	result := StringReplace(result, '&int;','', [rfReplaceAll]);			//	&int;  &#8747;  integral [w]ϕL 
	result := StringReplace(result, '&there4;','', [rfReplaceAll]);		//	&there4;  &#8756;  therefore [w]䂦 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&sim; ? &#8764; ? tilde operator = varies with = similar to [w] 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&cong; ? &#8773; ? approximately equal to [w]قƂǓ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&asymp; ? &#8776; ? almost equal to = asymptotic to 
	result := StringReplace(result, '&ne;','', [rfReplaceAll]);			//	&ne;  &#8800;  not equal to [w]Ȃ 
	result := StringReplace(result, '&equiv;','', [rfReplaceAll]);		//	&equiv;  &#8801;  identical to [w] 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&le; ? &#8804; ? less-than or equal to [w]菬܂͓ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&ge; ? &#8805; ? greater-than or equal to [w]傫܂͓ 
	result := StringReplace(result, '&sub;','', [rfReplaceAll]);			//	&sub;  &#8834;  subset of [w]^W ܂܂ 
	result := StringReplace(result, '&sup;','', [rfReplaceAll]);			//	&sup;  &#8835;  superset of [w]^W ܂ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&nsub; ? &#8836; ? not a subset of [w]^W ܂܂Ȃ 
	result := StringReplace(result, '&sube;','', [rfReplaceAll]);			//	&sube;  &#8838;  subset of or equal to [w]W ܂܂ 
	result := StringReplace(result, '&supe;','', [rfReplaceAll]);			//	&supe;  &#8839;  superset of or equal to [w]W ܂ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&oplus; ? &#8853; ? circled plus = direct sum 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&otimes; ? &#8855; ? circled times = vector product 
	result := StringReplace(result, '&perp;','', [rfReplaceAll]);			//	&perp;  &#8869;  up tack = orthogonal to = perpendicular [w] 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&sdot; ? &#8901; ? dot operator hbgZq 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lceil; ? &#8968; ? left ceiling = apl upstile [w]͂ݏ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&rceil; ? &#8969; ? right ceiling [w]E͂ݏ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lfloor; ? &#8970; ? left floor = apl downstile [w]͂݉ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&rfloor; ? &#8971; ? right floor [w]E͂݉ 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&lang; ? &#9001; ? left-pointing angle bracket = bra  
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&rang; ? &#9002; ? right-pointing angle bracket = ket E 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&loz; ? &#9674; ? lozenge Ђ` 

//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&spades; ? &#9824; ? black spade suit Xy[h 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&clubs; ? &#9827; ? black club suit = shamrock Nu 
//	result := StringReplace(result, '&hearts;',#$26#$65, [rfReplaceAll]);	//	&hearts; ? &#9829; ? black heart suit = valentine n[g 
//	result := StringReplace(result, '','', [rfReplaceAll]);					//	&diams; ? &#9830; ? black diamond suit _C 

//		result := StringReplace(result, '&#8451;','', [rfReplaceAll]);	//	&#8451;  ێxL 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8467; ? bgL 
//		result := StringReplace(result, '&#8470;','', [rfReplaceAll]);	//	&#8470;  No. 
//		result := StringReplace(result, '&#8481;','', [rfReplaceAll]);	//	&#8481;  TEL 
//		result := StringReplace(result, '&#8544;','T', [rfReplaceAll]);	//	&#8544; T [}1 
//		result := StringReplace(result, '&#8545;','U', [rfReplaceAll]);	//	&#8545; U [}2 
//		result := StringReplace(result, '&#8546;','V', [rfReplaceAll]);	//	&#8546; V [}3 
//		result := StringReplace(result, '&#8547;','W', [rfReplaceAll]);	//	&#8547; W [}4 
//		result := StringReplace(result, '&#8548;','X', [rfReplaceAll]);	//	&#8548; X [}5 
//		result := StringReplace(result, '&#8549;','Y', [rfReplaceAll]);	//	&#8549; Y [}6 
//		result := StringReplace(result, '&#8550;','Z', [rfReplaceAll]);	//	&#8550; Z [}7 
//		result := StringReplace(result, '&#8551;','[', [rfReplaceAll]);	//	&#8551; [ [}8 
//		result := StringReplace(result, '&#8552;','\', [rfReplaceAll]);	//	&#8552; \ [}9 
//		result := StringReplace(result, '&#8553;',']', [rfReplaceAll]);	//	&#8553; ] [}10 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8554; ? [}11 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8555; ? [}12 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8556; ? [}50 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8557; ? [}100 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8558; ? [}500 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#8559; ? [}1000 
//		result := StringReplace(result, '&#9312;','@', [rfReplaceAll]);	//	&#9312; @ ۂ1 
//		result := StringReplace(result, '&#9313;','A', [rfReplaceAll]);	//	&#9313; A ۂ2 
//		result := StringReplace(result, '&#9314;','B', [rfReplaceAll]);	//	&#9314; B ۂ3 
//		result := StringReplace(result, '&#9315;','C', [rfReplaceAll]);	//	&#9315; C ۂ4 
//		result := StringReplace(result, '&#9316;','D', [rfReplaceAll]);	//	&#9316; D ۂ5 
//		result := StringReplace(result, '&#9317;','E', [rfReplaceAll]);	//	&#9317; E ۂ6 
//		result := StringReplace(result, '&#9318;','F', [rfReplaceAll]);	//	&#9318; F ۂ7 
//		result := StringReplace(result, '&#9319;','G', [rfReplaceAll]);	//	&#9319; G ۂ8 
//		result := StringReplace(result, '&#9320;','H', [rfReplaceAll]);	//	&#9320; H ۂ9 
//		result := StringReplace(result, '&#9321;','I', [rfReplaceAll]);	//	&#9321; I ۂ10 
//		result := StringReplace(result, '&#9322;','J', [rfReplaceAll]);	//	&#9322; J ۂ11 
//		result := StringReplace(result, '&#9323;','K', [rfReplaceAll]);	//	&#9323; K ۂ12 
//		result := StringReplace(result, '&#9324;','L', [rfReplaceAll]);	//	&#9324; L ۂ13 
//		result := StringReplace(result, '&#9325;','M', [rfReplaceAll]);	//	&#9325; M ۂ14 
//		result := StringReplace(result, '&#9326;','N', [rfReplaceAll]);	//	&#9326; N ۂ15 
//		result := StringReplace(result, '&#9327;','O', [rfReplaceAll]);	//	&#9327; O ۂ16 
//		result := StringReplace(result, '&#9328;','P', [rfReplaceAll]);	//	&#9328; P ۂ17 
//		result := StringReplace(result, '&#9329;','Q', [rfReplaceAll]);	//	&#9329; Q ۂ18 
//		result := StringReplace(result, '&#9330;','R', [rfReplaceAll]);	//	&#9330; R ۂ19 
//		result := StringReplace(result, '&#9331;','S', [rfReplaceAll]);	//	&#9331; S ۂ20 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12832; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12833; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12834; ? ۂO 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12835; ? ۂl 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12836; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12837; ? ۂZ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12838; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12839; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12840; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12841; ? ۂ\ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12842; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12843; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12844; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12845; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12846; ? ۂ 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12847; ? ۂy 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12848; ? ۂ 
//		result := StringReplace(result, '&#12849;','', [rfReplaceAll]);	//	&#12849;  ۂ 
//		result := StringReplace(result, '&#12850;','', [rfReplaceAll]);	//	&#12850;  ۂL 
//	//	result := StringReplace(result, '','', [rfReplaceAll]);				//	&#12851; ? ۂ 
end;
//------------------------------------------------------------------
//
//
//
//------------------------------------------------------------------
function LoadCookie(): string;
var
// E@Ή
  str: string;
  CookieIni : TIniFile;
//SetCookie: string;
  Count:integer;
  i: integer;
  lst:TStrings;

  Section:string;
  Ident:string;
  Value:string;
begin
  CookieIni:=TIniFile.Create(AppPath(FILE_COOKIEINI));
  lst:=TStringList.Create;
  CookieIni.ReadSection('Main',lst);    // [Main]ׂ̂Ăǂݍ
  Result:='';
  Section:='Main';
  for i:=0 to lst.Count-1 do
  begin
    Ident:=lst.Strings[i];
    Value:=CookieIni.ReadString(Section,Ident,'');
    if((Ident<>'expires') and (Ident<>'path')) then
    begin
      str:=Ident+'='+Value;
      if Result='' then
        Result:=Result+str
      else
        Result:=Result+' '+str;
    end;
  end;

  lst.Free;
  CookieIni.Free;
end;

procedure SaveCookie(s: string);
var
// E@Ή
  str: string;
  CookieIni : TIniFile;
//SetCookie: string;
  Count:integer;
  i: integer;
  lst:TStrings;

  Section:string;
  Ident:string;
  Value:string;
begin
  CookieIni:=TIniFile.Create(AppPath(FILE_COOKIEINI));
  lst:=TStringList.Create;

  // Cookie𕪉
  lst.Clear();
  Count:=Length(s);
  if(Count<>0) then
  begin
    str:='';
    for i:=1 to Count do
    begin
      str:=str+s[i];
      if s[i]=';' then
      begin
        str:=Trim(str);
        lst.Add(str);
        str:='';
      end;
    end;
  
    // Cookie(㏑)ۑ
    Section:='Main';
    for i:=0 to lst.Count-1 do
    begin
      Ident:=lst.Names[i];
      Value:=lst.Values[Ident];
      CookieIni.WriteString(Section,Ident,Value);
    end;
  end;

  lst.Free;
  CookieIni.Free;
end;
//------------------------------------------------------------------
//
//
//
//------------------------------------------------------------------
initialization
  OleInitialize(nil);

  // ݒǂݏo
  gConfig := TConfig.Create(AppPath(FILE_OPTIONINI));
  gConfig.ReadOption();

  // eCX^X̍쐬
  gFolderAlias := TFolderAlias.Create;
  gDolibLogin  := TDolibLogin.Create;
  gTaskManager := TTaskmanager.Create;
  gSynchronizer := TSynchronizer.Create(True);

  if gConfig.AutoLogin then
  begin
    gDolibLogin.Login();    
  end;

finalization
  // eCX^X̔p
  gFolderAlias.Free;
  gDolibLogin.Free;
  gTaskManager.Free;
  gSynchronizer.Free;

  // ݒ菑o
  gConfig.WriteOption();
  gConfig.Free;

  OleUninitialize;

end.
